{$WARN UNIT_PLATFORM OFF}
unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, Gauges, SelectDirectoryDialog;

type
  TMainForm = class(TForm)
    MainPC: TPageControl;
    NM2NM3ts: TTabSheet;
    NM3NM2ts: TTabSheet;
    NM2FilesLB: TListBox;
    Panel1: TPanel;
    Panel2: TPanel;
    BrowseBtn: TButton;
    IndexL: TLabel;
    Panel3: TPanel;
    IndexM: TMemo;
    NoteL: TLabel;
    NM2FilesL: TLabel;
    Panel4: TPanel;
    AddBtn: TButton;
    RemoveBtn: TButton;
    IndexOD: TOpenDialog;
    NM2OD: TOpenDialog;
    TargetSD: TSaveDialog;
    Panel5: TPanel;
    NM3FileL: TLabel;
    Panel6: TPanel;
    BrowseNM3Btn: TButton;
    Panel7: TPanel;
    NM3FileM: TMemo;
    Note2L: TLabel;
    NM3OD: TOpenDialog;
    CreatorL: TStaticText;
    Panel8: TPanel;
    Panel9: TPanel;
    ConvertBtn: TButton;
    Panel10: TPanel;
    Progressbar1G: TGauge;
    Panel11: TPanel;
    Panel12: TPanel;
    ConvertNM3Btn: TButton;
    Panel13: TPanel;
    Progressbar2G: TGauge;
    Panel14: TPanel;
    TargetDirL: TLabel;
    Panel15: TPanel;
    BrowseDirBtn: TButton;
    Panel16: TPanel;
    TargetDirM: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BrowseBtnClick(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
    procedure RemoveBtnClick(Sender: TObject);
    procedure ConvertBtnClick(Sender: TObject);
    procedure BrowseNM3BtnClick(Sender: TObject);
    procedure BrowseDirBtnClick(Sender: TObject);
    procedure ConvertNM3BtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    SelectDirectoryDialog: TSelectDirectoryDialog;
    first : boolean;
    procedure SetUIWorking(working:boolean);
    procedure UpdatePB(Progressbar:TGauge; Progress:integer);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure FormToCenter(Form:TForm);
  begin with Form do begin
    if Height>Screen.WorkAreaHeight then Height:=Screen.WorkAreaHeight;
    if Width>Screen.WorkAreaWidth then Width:=Screen.WorkAreaWidth;
    Top:=(Screen.WorkAreaHeight div 2)-(Height div 2);
    if Top<0 then Top:=0;
    Left:=(Screen.WorkAreaWidth div 2)-(Width div 2);
    if Left<0 then Left:=0;
  end; end;

function OPath(const s:string):string;  // returns Only the Path
  var
    i : longint;
  begin
    i:=length(s);
    while ((i>0) and (s[i]<>'\')) do dec(i);
    Result:=copy(s,1,i);
  end;

function IntToStrLZ(Number, NumLength:integer):string;
  begin
    Result:=IntToStr(Number);
    while (Length(Result)<NumLength) do Result:='0'+Result;
  end;

procedure TMainForm.FormCreate(Sender: TObject);
  begin
    SelectDirectoryDialog:=TSelectDirectoryDialog.Create(self);
    IndexOD.InitialDir:='.';
    NM2OD.InitialDir:='.';
    TargetSD.InitialDir:='.';
    NM3OD.InitialDir:='.';
    SelectDirectoryDialog.InitialDir:='.';
    first:=true;
  end;

procedure TMainForm.FormActivate(Sender: TObject);
  begin
    if first then begin
      FormToCenter(self);
      IndexM.SetFocus;
      first:=false;
    end;
  end;

procedure TMainForm.FormDestroy(Sender: TObject);
  begin
    SelectDirectoryDialog.Destroy;
  end;

procedure TMainForm.SetUIWorking(working:boolean);
  begin
    if working then begin
      MainPC.Enabled:=false;
      IndexM.Enabled:=false;
      IndexM.Color:=clInactiveCaptionText;
      BrowseBtn.Enabled:=false;
      NM2FilesLB.Enabled:=false;
      NM2FilesLB.Color:=clInactiveCaptionText;
      AddBtn.Enabled:=false;
      RemoveBtn.Enabled:=false;
      ConvertBtn.Enabled:=false;
      NM3FileM.Enabled:=false;
      NM3FileM.Color:=clInactiveCaptionText;
      BrowseNM3Btn.Enabled:=false;
      ConvertNM3Btn.Enabled:=false;
    end else begin
      MainPC.Enabled:=true;
      IndexM.Enabled:=true;
      IndexM.Color:=clWindow;
      BrowseBtn.Enabled:=true;
      NM2FilesLB.Enabled:=true;
      NM2FilesLB.Color:=clWindow;
      AddBtn.Enabled:=true;
      RemoveBtn.Enabled:=true;
      ConvertBtn.Enabled:=true;
      NM3FileM.Enabled:=true;
      NM3FileM.Color:=clWindow;
      BrowseNM3Btn.Enabled:=true;
      ConvertNM3Btn.Enabled:=true;
    end;
    Application.ProcessMessages;
  end;

procedure TMainForm.UpdatePB(Progressbar:TGauge; Progress:integer);
  begin
    Progressbar.Progress:=Progress;
    Application.ProcessMessages;
  end;

procedure TMainForm.BrowseBtnClick(Sender: TObject);
  begin
    IndexOD.FileName:=IndexM.Text;
    if IndexOD.Execute then IndexM.Text:=IndexOD.FileName;
  end;

procedure TMainForm.AddBtnClick(Sender: TObject);
  begin
    NM2OD.FileName:='';
    if NM2OD.Execute then NM2FilesLB.Items.AddStrings(NM2OD.Files);
  end;

procedure TMainForm.RemoveBtnClick(Sender: TObject);
  begin
    NM2FilesLB.DeleteSelected;
  end;

{$WARNINGS OFF}
procedure TMainForm.ConvertBtnClick(Sender: TObject);
  var
    f : file;
    b1 : array[0..3] of char;  // Buffer1
    ok : boolean;
    i,transferred : integer;
    TotalSize: DWORD;
    offsets : TMemoryStream;
    tf,sf : TFileStream; // TargetFile, SourceFile
  begin
    // checking all files
    ok:=true; TotalSize:=0; offsets:=TMemoryStream.Create;
    if (not FileExists(IndexM.Text)) then begin
      ok:=false;
      MessageDlg('Index file does not exist!',mtError,[mbOK],0);
    end else begin
      AssignFile(f,IndexM.Text);
      try
        Reset(f,1);
        inc(TotalSize,FileSize(f));
        offsets.Write(TotalSize,sizeof(TotalSize));
        try
          BlockRead(f,b1,sizeof(b1),transferred);
        finally
          CloseFile(f);
        end;
      except
        ok:=false;
        MessageDlg('Can'#39't read the Index file!',mtError,[mbOK],0);
      end;
      if ok then begin
        if (b1<>'NIDX') then begin
          ok:=false;
          MessageDlg('Index file is not a proper Index file!',mtError,[mbOK],0);
        end;
      end;
      if (ok and (NM2FilesLB.Count<1)) then begin
        ok:=false;
        MessageDlg('You need to specify at least one NM2 file!',mtError,[mbOK],0);
      end;
      i:=0;
      while (ok and (i<=NM2FilesLB.Count-1)) do begin
        if (not FileExists(NM2FilesLB.Items[i])) then begin
          ok:=false;
          MessageDlg('File does not exist: '+NM2FilesLB.Items[i],mtError,[mbOK],0);
        end else begin
          AssignFile(f,NM2FilesLB.Items[i]);
          try
            Reset(f,1);
            inc(TotalSize,FileSize(f));
            if (i<NM2FilesLB.Count-1) then offsets.Write(TotalSize,sizeof(TotalSize));
            try
              BlockRead(f,b1,sizeof(b1),transferred);
            finally
              CloseFile(f);
            end;
          except
            ok:=false;
            MessageDlg('Can'#39't read file: '+NM2FilesLB.Items[i],mtError,[mbOK],0);
          end;
          if ok then begin
            if (b1<>'GNTM') then begin
              ok:=false;
              MessageDlg('NM2 file is not a proper NM2 file: '+NM2FilesLB.Items[i],mtError,[mbOK],0);
            end else b1[3]:=#255; // erasing b1 before the next cycle :)
          end;
        end;
        inc(i);
      end;
    end;
    // if everything is ok
    if (ok and TargetSD.Execute) then begin
      Progressbar1G.Visible:=true;
      Progressbar1G.Progress:=0;
      SetUIWorking(true);
      try
        tf:=TFileStream.Create(TargetSD.FileName,fmCreate or fmShareExclusive);
      except
        ok:=false;
        MessageDlg('Can'#39't create the target file!',mtError,[mbOK],0);
      end;
      if ok then begin
        try try
          b1:='GNM3';
          if (tf.Write(b1,sizeof(b1))<>sizeof(b1)) then raise Exception.Create('');
          b1:=#0#0#0#0;
          if (tf.Write(b1,sizeof(b1))<>sizeof(b1)) then raise Exception.Create('');
          // TotalSize is actually an offset of the files offsets on the end of the file
          if (tf.Write(TotalSize,sizeof(TotalSize))<>sizeof(TotalSize)) then raise Exception.Create('');
          try
            sf:=TFileStream.Create(IndexM.Text,fmOpenRead or fmShareDenyWrite);
          except
            ok:=false;
            MessageDlg('Can'#39't open the Index file!',mtError,[mbOK],0);
          end;
          if ok then begin
            try try
              tf.CopyFrom(sf,0);
              UpdatePB(Progressbar1G,Round(100/(NM2FilesLB.Count+1)));
            finally sf.Destroy; end;
            except on EReadError do begin
              ok:=false;
              MessageDlg('Can'#39't read from Index file!',mtError,[mbOK],0);
            end; end;
          end;
          i:=0;
          while (ok and (i<=NM2FilesLB.Count-1)) do begin
            try
              sf:=TFileStream.Create(NM2FilesLB.Items[i],fmOpenRead or fmShareDenyWrite);
            except
              ok:=false;
              MessageDlg('Can'#39't open file: '+NM2FilesLB.Items[i],mtError,[mbOK],0);
            end;
            if ok then begin
              try try
                tf.CopyFrom(sf,0);
                UpdatePB(Progressbar1G,Round(100*(i+2)/(NM2FilesLB.Count+1)));
              finally sf.Destroy; end;
              except on EReadError do begin
                ok:=false;
                MessageDlg('Can'#39't read from file: '+NM2FilesLB.Items[i],mtError,[mbOK],0);
              end; end;
            end;
            inc(i);
          end;
          // Files' offsets
          tf.CopyFrom(offsets,0);
        finally tf.Destroy; end;
        except
          MessageDlg('Can'#39't write to the target file!',mtError,[mbOK],0);
        end;
      end;
      SetUIWorking(false);
    end;
    offsets.Destroy;
  end;
{$WARNINGS ON}

procedure TMainForm.BrowseNM3BtnClick(Sender: TObject);
  begin
    NM3OD.FileName:=NM3FileM.Text;
    if NM3OD.Execute then NM3FileM.Text:=NM3OD.FileName;
  end;

procedure TMainForm.BrowseDirBtnClick(Sender: TObject);
  begin
    if (TargetDirM.Text='') then begin
      if (NM3FileM.Text='') then begin
        SelectDirectoryDialog.Directory:=OPath(ParamStr(0));
      end else begin
        SelectDirectoryDialog.Directory:=OPath(NM3FileM.Text);
      end;
    end else begin
      SelectDirectoryDialog.Directory:=TargetDirM.Text;
    end;
    if SelectDirectoryDialog.Execute then TargetDirM.Text:=SelectDirectoryDialog.Directory;
  end;

{$WARNINGS OFF}
procedure TMainForm.ConvertNM3BtnClick(Sender: TObject);
  var
    f : file;
    b1 : array[0..3] of char;  // Buffer1
    ok : boolean;
    transferred : integer;
    i,ii, start, offsetsstart, prev: DWORD;
    sizes : array of DWORD;
    fn : string;
    tf,sf : TFileStream; // TargetFile, SourceFile
  begin
    // checking the file
    ok:=true;
    if (not FileExists(NM3FileM.Text)) then begin
      ok:=false;
      MessageDlg('NM3 file does not exist!',mtError,[mbOK],0);
    end else begin
      AssignFile(f,NM3FileM.Text);
      try
        Reset(f,1);
        try
          BlockRead(f,b1,sizeof(b1),transferred);
          if (b1<>'GNM3') then begin
            ok:=false;
            MessageDlg('The NM3 file is not a proper NM3 file!',mtError,[mbOK],0);
          end else begin
            BlockRead(f,i,sizeof(i),transferred);
            if (transferred<>sizeof(i)) then raise Exception.Create('');
            BlockRead(f,ii,sizeof(ii),transferred);
            if (transferred<>sizeof(ii)) then raise Exception.Create('');
            if (i<>0) or (ii>DWORD(FileSize(f))) then begin  // so its an official NM3
              while (ii>DWORD(FileSize(f))) do begin
                BlockRead(f,ii,sizeof(ii),transferred);
                if (transferred<>sizeof(ii)) then raise Exception.Create('');
              end;
              while (b1<>'NIDX') do begin
                BlockRead(f,b1,sizeof(b1),transferred);
                if (transferred<>sizeof(b1)) then raise Exception.Create('');
              end;
              start:=FilePos(f)-sizeof(b1);
            end else begin  // so its a user-made NM3
              start:=12;
            end;
            offsetsstart:=ii+start;
            SetLength(sizes,0);
            Seek(f,offsetsstart);
            ii:=0; transferred:=sizeof(i); prev:=0; i:=1;
            while (sizeof(i)=transferred) and (i>prev) do begin
              prev:=i;
              BlockRead(f,i,sizeof(i),transferred);
              if (sizeof(i)=transferred) and (i>prev) then begin
                SetLength(sizes,Length(sizes)+1);
                sizes[high(sizes)]:=i;
                dec(sizes[high(sizes)],ii);
                inc(ii,sizes[high(sizes)]);
              end;
            end;
            SetLength(sizes,Length(sizes)+1);
            sizes[high(sizes)]:=offsetsstart-ii-start;
          end;
        finally
          CloseFile(f);
        end;
      except
        ok:=false;
        MessageDlg('Can'#39't read the NM3 file!',mtError,[mbOK],0);
      end;
    end;
    if ok then begin
      if (copy(TargetDirM.Text,length(TargetDirM.Text),1)='\')
        then TargetDirM.Text:=copy(TargetDirM.Text,1,length(TargetDirM.Text)-1);
      if (not DirectoryExists(TargetDirM.Text)) then begin
        ok:=false;
        MessageDlg('The target directory does not exist!',mtError,[mbOK],0);
      end;
    end;
    if ok then begin
      Progressbar2G.Visible:=true;
      Progressbar2G.Progress:=0;
      SetUIWorking(true);
      try
        sf:=TFileStream.Create(NM3FileM.Text,fmOpenRead or fmShareDenyWrite);
        sf.Seek(start,soFromBeginning);
      except
        ok:=false;
        MessageDlg('Can'#39't open the NM3 file!',mtError,[mbOK],0);
      end;
      i:=low(sizes);
      try try
        while (ok and (i<=high(sizes))) do begin
          fn:=TargetDirM.Text+'\';
          if (i=low(sizes)) then fn:=fn+'Index.nti' else fn:=fn+IntToStrLZ(i,6)+'.nm2';
          try
            tf:=TFileStream.Create(fn,fmCreate or fmShareExclusive);
          except
            ok:=false;
            MessageDlg('Can'#39't create the target file!',mtError,[mbOK],0);
          end;
          if ok then begin
            try try
              tf.CopyFrom(sf,sizes[i]);
              UpdatePB(Progressbar2G,Round(100*(i+1)/(Length(sizes))));
            finally tf.Destroy; end;
            except on EWriteError do begin
              ok:=false;
              MessageDlg('Can'#39't write to target file!',mtError,[mbOK],0);
            end; end;
          end;
          inc(i);
        end;
      finally sf.Destroy; end;
      except
        MessageDlg('Can'#39't read the NM3 file!',mtError,[mbOK],0);
      end;
      SetUIWorking(false);
    end;
    SetLength(sizes,0);
  end;
{$WARNINGS ON}

end.
